# Haskell text faces and other stuff related to syntax highlighting
# for Haskell in Kakoune, because I prefer different color arrangements
# per language.

{ theme, pkgs, ... }: pkgs.writeTextFile (rec {
    name = "rust.kak";
    destination = "/share/kak/colors/${name}";
    text = with theme; ''

    	# Types
		face global variant 	rgb:${blue.normal}+b
		face global enum		rgb:${blue.normal}+b
		face global struct		rgb:${blue.normal}+b
		face global alias		rgb:${blue.normal}+b
		face global primitive	rgb:${blue.normal}+b
		face global union		rgb:${blue.normal}+b
		face global trait		rgb:${purple.bright}+b

		# Other Rust-specific syntax elements
		face global lifetime	rgb:${cyan.bright}
		face global macro		rgb:${green.bright}+b
		face global format		macro

		# Keywords
    	face global keyword		rgb:${green.normal}

		# Literals
		face global literal		rgb:${misc.lime}
		face global string 		literal

		# Items
		# face global function	rgb:ff70cd
		face global function	rgb:fc7cf8
		face global method		function
		face global module		rgb:${misc.blueGrey}

		# Other stuff
		face global attribute	comment
		face global variable	rgb:f5f5f5
		face global property	rgb:${misc.lime}
		face global operator	rgb:${yellow.normal}
		face global punctuation	rgb:${foreground.normal}

    '';
})
